using System;
using System.Runtime.InteropServices;
using System.Text;

namespace OpenNETCF.Compression
{
    [StructLayout(LayoutKind.Sequential)]
    public struct gz_header
    {
        int text;       /* true if compressed data believed to be text */
        uint time;       /* modification time */
        int xflags;     /* extra flags (not used when writing a gzip file) */
        int os;         /* operating system */
        IntPtr extra;     /* pointer to extra field or Z_NULL if none */
        uint extra_len;  /* extra field length (valid if extra != Z_NULL) */
        uint extra_max;  /* space at extra (only when reading header) */
        IntPtr name;      /* pointer to zero-terminated file name or Z_NULL */
        uint name_max;   /* space at name (only when reading header) */
        IntPtr comment;   /* pointer to zero-terminated comment or Z_NULL */
        uint comm_max;   /* space at comment (only when reading header) */
        int hcrc;       /* true if there was or will be a header crc */
        int done;       /* true when done reading gzip header (not used
                           when writing a gzip file) */
    }
}
